/*
 *  xfmedia - simple gtk2 media player based on xine
 *
 *  Copyright (c) 2004 Brian Tarricone, <bjt23@cornell.edu>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _XFMUSIC__MAINWIN_H_
#define _XFMUSIC__MAINWIN_H_

#include <gtk/gtkwidget.h>

#include "gtkxine.h"

#include "xfmedia-common.h"

G_BEGIN_DECLS

XfMediaMainwin *xfmedia_mainwin_new(GtkXine *gtkx, GtkWindow *video_window);
gboolean xfmedia_mainwin_get_file_info(XfMediaMainwin *mwin, const gchar *filename, gchar **name, gint *length);
void xfmedia_mainwin_add_file(XfMediaMainwin *mwin, const gchar *filename, gint index, gboolean defer_info);
void xfmedia_mainwin_set_song_label(XfMediaMainwin *mwin, const gchar *str);
void xfmedia_mainwin_create_systray_item(XfMediaMainwin *mwin);
void xfmedia_mainwin_connect_slider_callback(XfMediaMainwin *mwin);
void xfmedia_mainwin_disconnect_slider_callback(XfMediaMainwin *mwin);
void xfmedia_mainwin_set_play_buttons(XfMediaMainwin *mwin);
void xfmedia_mainwin_set_pause_buttons(XfMediaMainwin *mwin);
gboolean xfmedia_mainwin_do_autohide(XfMediaMainwin *mwin);
void xfmedia_mainwin_destroy(XfMediaMainwin *mwin);

G_END_DECLS
 
#endif
