/*
 *  xfmedia - simple gtk2 media player based on xine
 *
 *  Copyright (c) 2004 Brian Tarricone, <bjt23@cornell.edu>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __XFMEDIA_REMOTE_H_
#define __XFMEDIA_REMOTE_H_

#include <glib.h>

#include "xfmedia-common.h"

G_BEGIN_DECLS

#define XFMEDIA_REMOTE_CLEAR_PLAYLIST "clear_playlist"
#define XFMEDIA_REMOTE_LOAD_PLAYLIST  "load_playlist"
#define XFMEDIA_REMOTE_SAVE_PLAYLIST  "save_playlist"
#define XFMEDIA_REMOTE_ADD_FILE       "add_file"
#define XFMEDIA_REMOTE_REMOVE_FILE    "remove_file"
#define XFMEDIA_REMOTE_PLAY           "play"
#define XFMEDIA_REMOTE_PAUSE          "pause"
#define XFMEDIA_REMOTE_STOP           "stop"
#define XFMEDIA_REMOTE_PREV           "prev"
#define XFMEDIA_REMOTE_QUIT           "quit"

void xfmedia_remote_init(XfMediaMainwin *mwin);
void xfmedia_remote_cleanup(XfMediaMainwin *mwin);

gboolean xfmedia_remote_send_command(gint session_id, const gchar *command, ...);

G_END_DECLS

#endif
