/*
 *  xfmusic4-cli - simple cmdline test implementation using libxfmusic4
 *
 *  Copyright (c) 2004 Brian Tarricone, <bjt23@cornell.edu>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <glib.h>

#include <libxfmusic4/libxfmusic4.h>

#ifndef _XFMUSIC__CLI_MISC_H_
#define _XFMUSIC__CLI_MISC_H_

G_BEGIN_DECLS

typedef struct _XFMData
{
	GMainLoop *mloop;
	gint verbose_level;
	XfMusic *xfmusic;
	guint posid;
	guint charid;
	gchar **files;
	gint num_files;
	gint cur_idx;
	gboolean quitting;
} XFMData;

void version();
void usage();
void print_stream_info(XfMusic *xfmusic);

G_END_DECLS

#endif
